package com.huimv.wine.ws;

import com.huimv.wine.utils.WebsocketWorkerUtil;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.handler.TextWebSocketHandler;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;

/**
 * websocket接口处理类
 */
@Component
@ServerEndpoint(value = "/worker/{seq}")
public class WorkerController extends TextWebSocketHandler {

    /**
     * 连接事件，加入注解
     */
    @OnOpen
    public void onOpen(@PathParam(value = "seq") String seq, Session session) {
        String message = "[" + seq + "]加入聊天室！！";
        System.out.println(message);

        // 添加到session的映射关系中
        WebsocketWorkerUtil.addSession(seq, session);
    }

    /**
     * 连接事件，加入注解
     * 用户断开链接
     */
    @OnClose
    public void onClose(@PathParam(value = "seq") String seq, Session session) {
        // 删除映射关系
        WebsocketWorkerUtil.removeSession(seq);
    }

    /**
     * 当接收到用户上传的消息
     */
    @OnMessage
    public void onMessage(@PathParam(value = "seq") String seq, Session session, String message) {
        String msg = "[" + seq + "]:" + message;
        System.out.println("接收到信息：" + msg);
    }

    /**
     * 处理用户活连接异常
     *
     * @param session
     * @param throwable
     */
    @OnError
    public void onError(Session session, Throwable throwable) {
        try {
            session.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        throwable.printStackTrace();
    }
}
